Please remove lupin from the archive

Bug #1960457 reported by Brian Murray
38
This bug affects 6 people
Affects Status Importance Assigned to Milestone
casper (Ubuntu)
Fix Released
Undecided
Łukasz Zemczak
lupin (Ubuntu)
Fix Released
Undecided
Unassigned

Bug Description

lupin is an Ubuntu native package that was used to facilitate WUBI installs of Ubuntu. However, WUBI is no longer a product Canonical produces or supports and subsequently we don't need to be keeping lupin around. Nothing depends on the source package or its binaries.

[ 1:30PM 11986 ] [ bdmurray@impulse:~/Downloads ]
 $ reverse-depends -r jammy src:lupin
[ 1:30PM 11987 ] [ bdmurray@impulse:~/Downloads ]
 $ reverse-depends -r focal src:lupin
[ 3:22PM 11993 ] [ bdmurray@impulse:~/Downloads ]

Having said that livecd-rootfs does try and install lupin-casper when building Ubuntu images but that is cruft but may need to be removed from livecd-rootfs before the package is removed.

Related branches

Revision history for this message
Steve Langasek (vorlon) wrote :

For completeness:

$ reverse-depends src:lupin -a source
No reverse dependencies found
$

Revision history for this message
Steve Langasek (vorlon) wrote :

yes, livecd-rootfs does need fixed first.

Changed in lupin (Ubuntu):
status: New → Incomplete
Revision history for this message
Brian Murray (brian-murray) wrote :

I've submitted a MP for dropping lupin-casper from livecd-rootfs here:

https://code.launchpad.net/~ubuntu-core-dev/livecd-rootfs/+git/livecd-rootfs/+merge/415346

Revision history for this message
Brian Murray (brian-murray) wrote :

I've uploaded a version of livecd-rootfs which switches from lupin-casper to just casper to Jammy today.

Revision history for this message
Steve Langasek (vorlon) wrote :

Removing packages from jammy:
 lupin 0.57build1 in jammy
  lupin-casper 0.57build1 in jammy amd64
  lupin-casper 0.57build1 in jammy arm64
  lupin-casper 0.57build1 in jammy armhf
  lupin-casper 0.57build1 in jammy i386
  lupin-casper 0.57build1 in jammy ppc64el
  lupin-casper 0.57build1 in jammy riscv64
  lupin-casper 0.57build1 in jammy s390x
  lupin-support 0.57build1 in jammy amd64
Comment: Ubuntu-specific, unmaintained, unneeded since wubi sunset as a project; LP: #1960457
1 package successfully removed.

Changed in lupin (Ubuntu):
status: Incomplete → Fix Released
Revision history for this message
Thomas (tk87) wrote :

Since lupin-casper (and related 20iso_scan) have been removed, it is no longer possible to boot the ubuntu-iso as loopback, because the parameter "iso-scan/filename" does not work anymore.
Will there be a replacement for this in the future? Otherwise, the loopback.cfg should also be removed from the images.

Revision history for this message
ubuntushop (g-info-l) wrote :

This will be a big problem for us for selling preloaded ubuntu computers.
We need the iso boot feature .

Revision history for this message
Steve Langasek (vorlon) wrote :

What exactly do you mean by "iso boot feature"? We certainly still support booting from an ISO filesystem (which all of our images are) from either optical media or a USB disk.

Revision history for this message
Thomas (tk87) wrote :

What we mean is to boot an ISO like this:

menuentry "Ubuntu 22.04 ISO" {
  set iso_path=/path/to/jammy-desktop-amd64.iso
  loopback loop ${iso_path}
  linux (loop)/casper/vmlinuz iso-scan/filename=${iso_path} boot=casper --
  initrd (loop)/casper/initrd
}

This works for all versions <= 21.10.

For Jammy this does not work anymore, because with lupin-casper also the iso-scan/filename handler (scripts/casper-premount/20iso_scan) was removed.

Thus, every attempt ends with the error message:
Unable to find a medium containing a live file system

Revision history for this message
ubuntushop (g-info-l) wrote :

We distribute free usb sticks with ubuntu, kubuntu, xubuntu etc...
These sticks has the different iso images that can be booted with grub and iso boot.
Users can choose what versions to install.
But if iso boot is removed in 22.04, we cannot offer these anymore.

We install also our oem pre-installed ubuntu computers with iso-boot and preseed , fully automatic

Thomas (tk87)
Changed in lupin (Ubuntu):
assignee: nobody → Thomas (tk87)
assignee: Thomas (tk87) → nobody
Revision history for this message
ubuntushop (g-info-l) wrote (last edit ):

Can someone tell me if the lupin-casper packages will be removed from the final 22.04 release?
We do alot of free remote installations on computers, even on win10 machines and remote reinstallations of ubuntu.
This service completely depends on iso booting with grub.
Without iso boot, we cannot continue this service.

Revision history for this message
Steve Langasek (vorlon) wrote : Re: [Bug 1960457] Re: Please remove lupin from the archive

On Tue, Apr 05, 2022 at 03:43:49PM -0000, ubuntushop wrote:
> Can someone tell me if the lupin-casper packages will be removed from
> the final 22.04 release?

It will. However, we are looking at merging the core functionality into
the casper package itself. There is no evident reason to have this in a
separate package which advertises itself as Wubi-related.

Revision history for this message
ubuntushop (g-info-l) wrote :

Thanks.
But will it land in 22.04?
We have to decide here if we can continue offering ubuntu 22.04 hw and services.

Revision history for this message
ubuntushop (g-info-l) wrote :
Revision history for this message
T (tstechster) wrote :

Are there any updates on this? I am still unsuccessful booting the iso from grub using loopback. When will the core functionality from lupin-casper be merged back into caspe itself?

I agree that this is an essential tool.

Revision history for this message
Łukasz Zemczak (sil2100) wrote :

I have prepared an MP trying to re-introduce the 20iso_scan bits from lupin-casper into casper itself - doing it by a rather straightforward copy-paste. Hope that's enough.

Changed in casper (Ubuntu):
assignee: nobody → Łukasz Zemczak (sil2100)
status: New → In Progress
Revision history for this message
ubuntushop (g-info-l) wrote :

ok, how can i test it?

Steve Langasek (vorlon)
Changed in casper (Ubuntu):
status: In Progress → Fix Committed
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package casper - 1.469

---------------
casper (1.469) jammy; urgency=medium

  * Integrate lupin-casper's 20iso_scan casper-premount script so that users
    can continue to use images that provide multiple iso's to choose to boot
    from. This was no longer possible after the removal of the lupin packages
    from jammy (LP: #1960457).

 -- Łukasz 'sil2100' Zemczak <email address hidden> Thu, 14 Apr 2022 15:04:19 +0200

Changed in casper (Ubuntu):
status: Fix Committed → Fix Released
Revision history for this message
ubuntushop (g-info-l) wrote (last edit ):

i have test this iso (15/4/2022)
https://cdimage.ubuntu.com/ubuntu-mate/daily-live/current/jammy-desktop-amd64.iso
boot with grub entry:
menuentry "Ubuntu OEM install 1 sata azerty(for manufacturers)" {
insmod loopback
 insmod iso9660
set isofile="/iso/jammy-desktop-amd64.iso"
 loopback loop $isofile
set root=(loop)
gfxpayload=keep
linux (loop)/casper/vmlinuz auto=true priority=critical boot=casper iso-scan/filename=$isofile keyboard-configuration/layoutcode=be console-setup/layoutcode=be only-ubiquity automatic-ubiquity oem-config/enable=true --
initrd (loop)/casper/initrd
}

But getting this error:
/scripts/casper-premount/20iso_scan: line 29 : find_path not found
could not find the ISO : /iso/jammy-desktop-amd64.iso

Is the kernel parameter : iso-scan/filename=
still valid?

Revision history for this message
ubuntushop (g-info-l) wrote :

could it be that this:
. /scripts/casper-helpers

must be added to
/scripts/casper-premount/20iso_scan

?

Revision history for this message
frostschutz (frostschutz) wrote :

Same results for me. Tested it with . scripts/casper-helpers added to 20iso_scan and it works although there are some odd messages left.

Another issue is filesystem support. The initrd only has access to ext234 and vfat. Once the livecd is booted, there is also exfat and ntfs3 (and various other Linux filesystems) available, but it's not yet availalbe in the initramfs stage.

Any chance we could still add those filesystem modules to initrd as well?

I think lupin-casper had previously also provided fuse/ntfs-3g, but with ntfs3 support in the kernel, it should be no longer necessary.

Revision history for this message
frostschutz (frostschutz) wrote :

The casper-helpers :: wait_for_devs() function has a locking file logic using this path "/dev/.initramfs/lupin-waited-for-devs"

    wait_for_devs(){
        if [ -e /dev/.initramfs/lupin-waited-for-devs ]; then
            return
        fi
        ...
        touch /dev/.initramfs/lupin-waited-for-devs
    }

When booting with isoscan this error message appears:

    touch: /dev/.initramfs/lupin-waited-for-devs: No such file or directory

The /dev/.initramfs/ dir does not seem to exist at all, so touch fails, and the locking never comes to pass. Maybe /dev/.initramfs was lupin specific?

There's another reference to /dev/.initramfs/ in /usr/lib/brltty/brltty.sh though. Unfortunately I'm not sure how to test that one.

isoscan still works regardless so this message can be ignored, just not sure if this locking is still relevant for anything. If it's not then maybe these 4 lines could just be commented out...

Revision history for this message
Steve Langasek (vorlon) wrote :

> Another issue is filesystem support. The initrd only has access to
> ext234 and vfat. Once the livecd is booted, there is also exfat and
> ntfs3 (and various other Linux filesystems) available, but it's not
> yet availalbe in the initramfs stage.

> Any chance we could still add those filesystem modules to initrd as well?

I see no code in the old lupin package that forced the inclusion of these other filesystem drivers. These drivers are not needed for the Ubuntu images that we generate, they are only useful if someone formats a USB stick with one of these filesystems and then places the Ubuntu images on them for use with loopback. I do not think it is justifiable to change the images to include other filesystem drivers at this point of the release cycle.

Revision history for this message
frostschutz (frostschutz) wrote :

It's actually still in there (fuse/ntfs-3g that is), I just missed it earlier, sorry.

As for exfat, well then maybe next time.

So ignoring everything else, that leaves including the casper-helpers to make it work at all:

--- initrd.old/scripts/casper-premount/20iso_scan 2022-04-15 19:24:07.449488141 +0200
+++ initrd.new/scripts/casper-premount/20iso_scan 2022-04-15 13:37:41.681205179 +0200
@@ -16,6 +16,7 @@
 esac

 . /scripts/casper-functions
+. /scripts/casper-helpers

 iso_path=
 for x in $(cat /proc/cmdline); do

Revision history for this message
ubuntushop (g-info-l) wrote :

It is working ok now.

Revision history for this message
cont (cont0) wrote :

iso booting works but all refers to wubi are deleted. Wubi is still alive and there are many users that are using it. I don't know why complicate everything when a few kb package didn't bother. Is it possible to get back the support for wubi integrated in casper?

Revision history for this message
T (tstechster) wrote :

Excellent! Thank you for the fix!

Revision history for this message
Steve Langasek (vorlon) wrote :

On Sat, Apr 16, 2022 at 02:10:02PM -0000, cont wrote:
> iso booting works but all refers to wubi are deleted. Wubi is still
> alive and there are many users that are using it.

There are many users using software that we have not supported since 2014?

Why?

Revision history for this message
cont (cont0) wrote (last edit ):

Because as I said there is an updated version, not official but always an updated version. My question is: could be implemented yet?

Revision history for this message
ubuntushop (g-info-l) wrote :

Will it be in the upcoming 22.04 release?
Because i see no
. /scripts/casper-helpers
in:

https://git.launchpad.net/casper/tree/scripts/casper-premount/20iso_scan

Revision history for this message
cont (cont0) wrote :

asaik casper is now 1.470 in the iso, there I see till 1.469. Maybe it's correct

Revision history for this message
cont (cont0) wrote :

If you see the source code of casper 1.470 it's correct.
http://archive.ubuntu.com/ubuntu/pool/main/c/casper/casper_1.470.tar.xz

Revision history for this message
ubuntushop (g-info-l) wrote (last edit ):

I used to boot ubuntu iso' from usb stick and add a preseed file with:
file=/isodevice/iso/ubulive.cfg
But casper cannot find this anymore. I do not find any /isodevice in mount command anymore.
Is this changed in ubuntu 22.04?

Revision history for this message
Martin Laclaustra (martin-laclaustra) wrote :

After the demise of lupin-casper, the port of its functions into casper itself is incomplete...

In casper/scripts/casper-bottom/05mountpoints the following is needed at the end (before log_end_msg)...

if grep -q '^[^ ]* /isodevice ' /proc/mounts; then
        mkdir -p /root/isodevice
        mount -n -o move /isodevice /root/isodevice
fi

(This was present in the now extinct package lupin-casper in lupin-0.57build1/casper/scripts/casper-bottom/05mountpoints_lupin)

The problem without these lines of code is that the partition remains mounted but the mount point is lost, it can not be unmounted, it locks the partition (avoiding changes in the disk when toram option is used), and also it prevents from accessing to files in that partition as the previous comment stated.

I hope that these four lines of code can be added to fix the problem.
@sil2100

To post a comment you must log in.
This report contains Public information  
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.